#include "Tetrakaidecahedra.h"
#include <fstream>
#include <math.h>
#include <iostream>
using namespace std;

int main()
{
	int caseNumber=1;
	int deformCase = 3;
	/*  DeformCase: 
	      1. Plain deformation
		  2. Axisymmetric tension
		  3. Axisymmetric Compression
		  4. Simple shear
		  5. Complex deformation
	*/
	//char savefilename[30];
	//sprintf_s(buf, "%s%d.dat", filename, version); 
	ofstream file;
    
	//file.open("plainDeformCase4.dat");
	//file.open("axisymmetricTensionDeformCase1.dat");
	//file.open("axisymmetricCompressionDeformCase1.dat");
	//file.open("simpleShearCase4.dat");
	//file.open("omplexDeformation-ps13-16.dat");
	double s13=16.0;
	int ix=2, iy=2,iz=2;
	double aL, aL0, aSv, aSv0, aLP, aLS, aV0;
	double epsplain, edgtheory, surftheory, dbi;
	Tetrakaidecahedra tetra(3, 2, 2, 5);
	printf("para     Sv/Sv0       L/L0       aSv/aSv0      aL/aL0");
	printf("para     aSv/aSv0      aL/aL0");
	//file<<"strain"<<" "<<"theoryEdge"<<" "<<"edgeRatio"
	//			<<" "<<"2ndaryEdge"<<" "<<"primaryEdge"
	//			<<" "<<"theorySurface"<<" "<<"areaRatio"<<"\n";

	for(double fl=0.; fl<0.51; fl+=0.5)
	//double fl=0.5;
	{
		printf("\n\nflunctuation = %f\n", fl);
		//for(int i=1; i<2; i++){
		//int i=2;{
		for(int i=1; i<13; i++){
			tetra.calcVtxCoord();
			tetra.ramdomizeVtx(fl);			
			tetra.zoomAllRandomTetra(caseNumber);
			
			//exit(1);
			
			dbi = i*1.0;

			if(deformCase == 1)
				tetra.setPlainDeformMatrix(dbi);
			if(deformCase == 2)
				tetra.setAxisymmetricTensionDeformMatrix(dbi);
			if(deformCase == 3)
				tetra.setAxisymmetricCompressionDeformMatrix(dbi);
			if(deformCase == 4)
				tetra.setSimpleShearDeformMatrix(dbi);


			if(deformCase == 5)
				tetra.setDeformationMatrix(dbi,0,s13/dbi,0,1,0,0,0,dbi);
				
			tetra.deformVtx();
			//tetra.outputVertex("tetra322.dat");
					
			if((i == 1 && deformCase !=4) || (i == 0 && deformCase == 4)){
				aL0 = tetra.getEdgeOfAllRandomTetra();
				aSv0 = tetra.getSurfaceAreaOfAllRandomTetra();
				aV0 = tetra.getVolumeOfAllRandomTetra();
			}

			if(deformCase == 1){ // plain strain  
				epsplain = 2.0*log(dbi)/sqrt(3.0); 
				edgtheory=(1+dbi+2*sqrt(1.0+dbi*dbi+2/dbi/dbi))/6.0;
				surftheory=(dbi+3*(dbi*sqrt(1.0+2.0/dbi/dbi)+sqrt(dbi*dbi
					+2.0/dbi/dbi))+sqrt(2.0*(1+dbi*dbi))/dbi)/(3*(2.0*sqrt(3.0)+1.0));
			}
			if(deformCase == 2){// axisymetric tension
				epsplain = log(dbi); 
				edgtheory=(dbi+1.0/dbi+2.0*sqrt(dbi*dbi+3.0/dbi))/6.0;
				surftheory=(sqrt(3*dbi)+sqrt(dbi+2.0/dbi/dbi)+1.0/3.0+sqrt(2*dbi
					+2/dbi/dbi)/3.0)/(2*sqrt(3.0)+1.0);
			}
			if(deformCase == 3){// axisymetric compression
				epsplain = sqrt(1.5)*log(dbi); 
				edgtheory=(sqrt(dbi)+sqrt(2*dbi*dbi+2/dbi))/3.0;
				surftheory=(sqrt(8.0*dbi+4.0/dbi/dbi)+(2*sqrt(dbi)+1.0/dbi)/3.0)/(2*sqrt(3.0)+1.0);
			}
			if(deformCase == 4){// simple shear
				epsplain = dbi;
				edgtheory=(1+sqrt(1+dbi*dbi/2.0-dbi/sqrt(2.0))+sqrt(1+dbi*dbi/2.0+dbi/sqrt(2.0)))/3.0;
				surftheory=(2+4*sqrt(1+dbi*dbi/4)+12*sqrt(3.0/4.0)
					+6*sqrt(3.0/4.0+dbi*dbi/2+dbi/sqrt(2.))
					+2*(sqrt(3+2*dbi*dbi-4*dbi/sqrt(2.0))+sqrt(3.0/4.0+dbi*dbi/2
					-dbi/sqrt(2.0))))/(2*sqrt(3.0)+1.0)/6.0;
			}
			if(deformCase == 5)
				epsplain = 2.0*log(dbi)/sqrt(3.0);
			aL = tetra.getEdgeOfAllRandomTetra();
			aLP = tetra.getPrimaryEdgeOfAllRandomTetra(); 
			aLS = tetra.getSecondaryEdgeOfAllRandomTetra();
			aSv = tetra.getSurfaceAreaOfAllRandomTetra();
			//tetra.sortVolumeCategary();
			//cout<<epsplain<<endl;
			cout<<(float)epsplain<<" "<<(float)edgtheory<<" "<<(float)aL/aL0
				<<" "<<(float)aLS<<" "<<(float)aLP
				<<" "<<(float)surftheory<<" "<<(float)aSv/aSv0<<"\n";
			//file<<(float)epsplain<<" "<<(float)aL/aL0<<" "<<(float)aSv/aSv0<<"\n";	
		}
		//file<<"fluct="<<fl<<" "<<"Lvo="<<" "<<(float)aL0<<" "<<"Svo="<<" "<<(float)aSv0
		//	<<" "<<"V="<<" "<<(float)aV0
		//	<<"\n";
	}
	file.close();
	return 1;
}